//---------------------------------------------------------------------------
// Generowanie kodow Pharmacode one-track
// www.algorytm.org
// (c)2007 Tomasz Lubinski
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"


TForm1 *Form1;
int curentPos;

// reurns 1 if txt is correct, 0 otherwise
int check(char *txt)
{
        int number;

        number = atoi(txt);
        if ((number < 3) || (number > 131070))
        {
                return 0;
        }

        return 1;
}

void drawSignBar(char bar)
{
        int nextPos = 0;

        Form1->Image1->Canvas->Brush->Color = clBlack;

        if (bar == 'W')
                nextPos = curentPos - 2*3;
        else
                nextPos = curentPos - 2;

        Form1->Image1->Canvas->Rectangle(curentPos + 20, 10, nextPos + 20, 70);
        curentPos = nextPos;

        curentPos -= 2*2;
}

void drawBars(char *txt)
{
        int number;

        curentPos = 300;
        Form1->Image1->Canvas->Brush->Color = clWhite;
        Form1->Image1->Canvas->Rectangle(0, 0, 337, 89);

        number = atoi(txt);

        while (number != 0)
        {
                if ((number % 2) == 0)
                {
                        drawSignBar('W');
                        number = (number-2)/2;
                }
                else
                {
                        drawSignBar('N');
                        number = (number-1)/2;
                }
        }
}

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button1Click(TObject *Sender)
{
        if (check(Kod->Text.c_str()) == 0)
        {
                ShowMessage("Incorrect text");
                return;
        }

        drawBars(Kod->Text.c_str());
}
//---------------------------------------------------------------------------
